blob: 1b9e67b2d1886bc8121e7f18743697453f89f3a6 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9#
10# vmlinux
11# ^
12# |
13# +-< $(KBUILD_VMLINUX_INIT)
14# | +--< init/version.o + more
15# |
16# +--< $(KBUILD_VMLINUX_MAIN)
17# | +--< drivers/built-in.o mm/built-in.o + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31# Nice output in kbuild format
32# Will be supressed by "make -s"
33info()
34{
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
37 fi
38}
39
Stephen Rothwella5967db2016-08-24 22:29:19 +100040# Thin archive build here makes a final archive with
41# symbol table and indexes from vmlinux objects, which can be
42# used as input to linker.
43#
44# Traditional incremental style of link does not require this step
45#
46# built-in.o output file
47#
48archive_builtin()
49{
50 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
51 info AR built-in.o
52 rm -f built-in.o;
53 ${AR} rcsT${KBUILD_ARFLAGS} built-in.o \
54 ${KBUILD_VMLINUX_INIT} \
55 ${KBUILD_VMLINUX_MAIN}
56 fi
57}
58
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020059# Link of vmlinux.o used for section mismatch analysis
60# ${1} output file
61modpost_link()
62{
Stephen Rothwella5967db2016-08-24 22:29:19 +100063 local objects
64
65 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
66 objects="--whole-archive built-in.o"
67 else
68 objects="${KBUILD_VMLINUX_INIT} \
69 --start-group \
70 ${KBUILD_VMLINUX_MAIN} \
71 --end-group"
72 fi
73 ${LD} ${LDFLAGS} -r -o ${1} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020074}
75
76# Link of vmlinux
77# ${1} - optional extra .o files
78# ${2} - output file
79vmlinux_link()
80{
81 local lds="${objtree}/${KBUILD_LDS}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100082 local objects
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020083
84 if [ "${SRCARCH}" != "um" ]; then
Stephen Rothwella5967db2016-08-24 22:29:19 +100085 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
86 objects="--whole-archive built-in.o ${1}"
87 else
88 objects="${KBUILD_VMLINUX_INIT} \
89 --start-group \
90 ${KBUILD_VMLINUX_MAIN} \
91 --end-group \
92 ${1}"
93 fi
94
95 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
96 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020097 else
Stephen Rothwella5967db2016-08-24 22:29:19 +100098 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
99 objects="-Wl,--whole-archive built-in.o ${1}"
100 else
101 objects="${KBUILD_VMLINUX_INIT} \
102 -Wl,--start-group \
103 ${KBUILD_VMLINUX_MAIN} \
104 -Wl,--end-group \
105 ${1}"
106 fi
107
108 ${CC} ${CFLAGS_vmlinux} -o ${2} \
109 -Wl,-T,${lds} \
110 ${objects} \
111 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200112 rm -f linux
113 fi
114}
115
116
117# Create ${2} .o file with all symbols from the ${1} object file
118kallsyms()
119{
120 info KSYM ${2}
121 local kallsymopt;
122
Rusty Russellb92021b2013-03-15 15:04:17 +1030123 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
124 kallsymopt="${kallsymopt} --symbol-prefix=_"
James Hogan6895f972012-09-06 22:11:25 +0100125 fi
126
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200127 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100128 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200129 fi
130
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700131 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030132 kallsymopt="${kallsymopt} --absolute-percpu"
133 fi
134
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700135 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
136 kallsymopt="${kallsymopt} --base-relative"
137 fi
138
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200139 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
140 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200141
Ard Biesheuvela0439342016-02-05 11:25:05 +0100142 local afile="`basename ${2} .o`.S"
143
144 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
145 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200146}
147
Arun Menon12e1b342017-07-27 10:41:57 -0700148# Generates ${2} .o file with RTIC MP's from the ${1} object file (vmlinux)
149# ${3} the file name where the sizes of the RTIC MP structure are stored
150# just in case, save copy of the RTIC mp to ${4}
151# Note: RTIC_MPGEN has to be set if MPGen is available
152rtic_mp()
153{
154 # assume that RTIC_MP_O generation may fail
155 RTIC_MP_O=
156
157 ${RTIC_MPGEN} --objcopy="${OBJCOPY}" --objdump="${OBJDUMP}" \
158 --binpath='' --vmlinux=${1} --config=${KCONFIG_CONFIG} && \
159 cat rtic_mp.c | ${CC} -c -o ${2} -x c - && \
160 cp rtic_mp.c ${4} && \
161 ${NM} --print-size --size-sort ${2} > ${3} && \
162 RTIC_MP_O=${2}
163 # NM - save generated variable sizes for verification
164 # RTIC_MP_O is our retval - great success if set to generated .o file
165}
166
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200167# Create map file with all symbols from ${1}
168# See mksymap for additional details
169mksysmap()
170{
171 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
172}
173
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700174sortextable()
175{
176 ${objtree}/scripts/sortextable ${1}
177}
178
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200179# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200180cleanup()
181{
182 rm -f .old_version
183 rm -f .tmp_System.map
184 rm -f .tmp_kallsyms*
185 rm -f .tmp_version
186 rm -f .tmp_vmlinux*
Stephen Rothwella5967db2016-08-24 22:29:19 +1000187 rm -f built-in.o
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200188 rm -f System.map
189 rm -f vmlinux
190 rm -f vmlinux.o
Arun Menon12e1b342017-07-27 10:41:57 -0700191 rm -f .tmp_rtic_mp_sz*
192 rm -f rtic_mp.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200193}
194
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000195on_exit()
196{
197 if [ $? -ne 0 ]; then
198 cleanup
199 fi
200}
201trap on_exit EXIT
202
203on_signals()
204{
205 exit 1
206}
207trap on_signals HUP INT QUIT TERM
208
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200209#
210#
211# Use "make V=1" to debug this script
212case "${KBUILD_VERBOSE}" in
213*1*)
214 set -x
215 ;;
216esac
217
218if [ "$1" = "clean" ]; then
219 cleanup
220 exit 0
221fi
222
223# We need access to CONFIG_ symbols
Michal Marek423a8152013-02-25 13:47:53 +0100224case "${KCONFIG_CONFIG}" in
225*/*)
226 . "${KCONFIG_CONFIG}"
227 ;;
228*)
229 # Force using a file from the current directory
230 . "./${KCONFIG_CONFIG}"
231esac
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200232
Stephen Rothwella5967db2016-08-24 22:29:19 +1000233archive_builtin
234
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200235#link vmlinux.o
236info LD vmlinux.o
237modpost_link vmlinux.o
238
239# modpost vmlinux.o to check for section mismatches
240${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
241
242# Update version
243info GEN .version
244if [ ! -r .version ]; then
245 rm -f .version;
246 echo 1 >.version;
247else
248 mv .version .old_version;
249 expr 0$(cat .old_version) + 1 >.version;
250fi;
251
252# final build of init/
Emese Revfy6b90bd42016-05-24 00:09:38 +0200253${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200254
Arun Menon12e1b342017-07-27 10:41:57 -0700255# Generate RTIC MP placeholder compile unit of the correct size
256# and add it to the list of link objects
257# this needs to be done before generating kallsyms
258if [ ! -z ${RTIC_MPGEN+x} ]; then
259 rtic_mp vmlinux.o rtic_mp.o .tmp_rtic_mp_sz1 .tmp_rtic_mp1.c
260 KBUILD_VMLINUX_MAIN+=" "
261 KBUILD_VMLINUX_MAIN+=$RTIC_MP_O
262fi
263
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200264kallsymso=""
265kallsyms_vmlinux=""
266if [ -n "${CONFIG_KALLSYMS}" ]; then
267
268 # kallsyms support
269 # Generate section listing all symbols and add it into vmlinux
270 # It's a three step process:
271 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
272 # but __kallsyms is empty.
273 # Running kallsyms on that gives us .tmp_kallsyms1.o with
274 # the right size
275 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
276 # the right size, but due to the added section, some
277 # addresses have shifted.
278 # From here, we generate a correct .tmp_kallsyms2.o
279 # 2a) We may use an extra pass as this has been necessary to
280 # woraround some alignment related bugs.
281 # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
282 # 3) The correct ${kallsymso} is linked into the final vmlinux.
283 #
284 # a) Verify that the System.map from vmlinux matches the map from
285 # ${kallsymso}.
286
287 kallsymso=.tmp_kallsyms2.o
288 kallsyms_vmlinux=.tmp_vmlinux2
289
290 # step 1
291 vmlinux_link "" .tmp_vmlinux1
292 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
293
294 # step 2
295 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
296 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
297
298 # step 2a
299 if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
300 kallsymso=.tmp_kallsyms3.o
301 kallsyms_vmlinux=.tmp_vmlinux3
302
303 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
304
305 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
306 fi
307fi
308
Arun Menon12e1b342017-07-27 10:41:57 -0700309# Update RTIC MP object by replacing the place holder
310# with actual MP data of the same size
311# Also double check that object size did not change
312if [ ! -z ${RTIC_MPGEN+x} ]; then
313 rtic_mp "${kallsyms_vmlinux}" rtic_mp.o .tmp_rtic_mp_sz2 \
314 .tmp_rtic_mp2.c
315 if ! cmp -s .tmp_rtic_mp_sz1 .tmp_rtic_mp_sz2; then
316 echo >&2 'ERROR: RTIC MP object files size mismatch'
317 exit 1
318 fi
319fi
320
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200321info LD vmlinux
322vmlinux_link "${kallsymso}" vmlinux
323
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700324if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
325 info SORTEX vmlinux
326 sortextable vmlinux
327fi
328
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200329info SYSMAP System.map
330mksysmap vmlinux System.map
331
332# step a (see comment above)
333if [ -n "${CONFIG_KALLSYMS}" ]; then
334 mksysmap ${kallsyms_vmlinux} .tmp_System.map
335
336 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200337 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200338 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200339 exit 1
340 fi
341fi
342
343# We made a new kernel - delete old version file
344rm -f .old_version